EVENTSERVEXAMP_NAME        = Go4EventServerExample
MODULE_NAME         = $(EVENTSERVEXAMP_NAME)

## normally should be like this for every module, but can be specific

ifdef GO4PACKAGE
EVENTSERVEXAMP_DIR         = $(GO4SYS)/$(EVENTSERVEXAMP_NAME)
else
EVENTSERVEXAMP_DIR         = .
endif

EVENTSERVEXAMP_LINKDEF     = $(EVENTSERVEXAMP_DIR)/$(EVENTSERVEXAMP_NAME)LinkDef.$(HedSuf)
EVENTSERVEXAMP_LIBNAME     = $(LIB_PREFIX)$(EVENTSERVEXAMP_NAME)
EVENTSERVEXAMP_EXENAME     = Main$(EVENTSERVEXAMP_NAME)
EVENTSERVEXAMP_ONLYMAP     = $(EVENTSERVEXAMP_DIR)/.localmap
EVENTSERVEXAMP_MAP         = $(EVENTSERVEXAMP_DIR)/$(ROOTMAPNAME)

EVENTSERVEXAMP_NOTLIBF     = 

## must be similar for every module

EVENTSERVEXAMP_EXEO        = $(EVENTSERVEXAMP_DIR)/$(EVENTSERVEXAMP_EXENAME).$(ObjSuf)
EVENTSERVEXAMP_EXES        = $(EVENTSERVEXAMP_DIR)/$(EVENTSERVEXAMP_EXENAME).$(SrcSuf)
EVENTSERVEXAMP_EXE         = $(EVENTSERVEXAMP_DIR)/$(EVENTSERVEXAMP_EXENAME)$(ExeSuf)   

EVENTSERVEXAMP_DICT        = $(EVENTSERVEXAMP_DIR)/$(DICT_PREFIX)$(EVENTSERVEXAMP_NAME)
EVENTSERVEXAMP_DH          = $(EVENTSERVEXAMP_DICT).$(HedSuf)
EVENTSERVEXAMP_DS          = $(EVENTSERVEXAMP_DICT).$(SrcSuf)
EVENTSERVEXAMP_DO          = $(EVENTSERVEXAMP_DICT).$(ObjSuf)

EVENTSERVEXAMP_H           = $(filter-out $(EVENTSERVEXAMP_EXEH) $(EVENTSERVEXAMP_NOTLIBF) $(EVENTSERVEXAMP_DH) $(EVENTSERVEXAMP_LINKDEF), $(wildcard $(EVENTSERVEXAMP_DIR)/*.$(HedSuf)))
EVENTSERVEXAMP_S           = $(filter-out $(EVENTSERVEXAMP_EXES) $(EVENTSERVEXAMP_NOTLIBF) $(EVENTSERVEXAMP_DS), $(wildcard $(EVENTSERVEXAMP_DIR)/*.$(SrcSuf)))
EVENTSERVEXAMP_O           = $(EVENTSERVEXAMP_S:.$(SrcSuf)=.$(ObjSuf))

EVENTSERVEXAMP_DEP         =  $(EVENTSERVEXAMP_O:.$(ObjSuf)=.$(DepSuf))
EVENTSERVEXAMP_DDEP        =  $(EVENTSERVEXAMP_DO:.$(ObjSuf)=.$(DepSuf))
EVENTSERVEXAMP_EDEP        =  $(EVENTSERVEXAMP_EXEO:.$(ObjSuf)=.$(DepSuf))

EVENTSERVEXAMP_SLIB        =  $(EVENTSERVEXAMP_DIR)/$(EVENTSERVEXAMP_LIBNAME).$(DllSuf)
EVENTSERVEXAMP_LIB         =  $(EVENTSERVEXAMP_DIR)/$(EVENTSERVEXAMP_LIBNAME).$(DllSuf).$(VERSSUF)

# used in the main Makefile

EXAMPDEPENDENCS    += $(EVENTSERVEXAMP_DEP) $(EVENTSERVEXAMP_DDEP) $(EVENTSERVEXAMP_EDEP)

ifdef DOPACKAGE
DISTRFILES         += $(EVENTSERVEXAMP_S) $(EVENTSERVEXAMP_H) $(EVENTSERVEXAMP_LINKDEF) $(EVENTSERVEXAMP_EXES)
endif

##### local rules #####

$(EVENTSERVEXAMP_EXE):     $(BUILDGO4LIBS) $(EVENTSERVEXAMP_EXEO) $(EVENTSERVEXAMP_LIB) 
	$(LD) $(LDFLAGS) $(EVENTSERVEXAMP_EXEO) $(LIBS_FULLSET) $(EVENTSERVEXAMP_LIB) $(OutPutOpt) $(EVENTSERVEXAMP_EXE)
	@echo "$@  done"      

$(EVENTSERVEXAMP_LIB):   $(EVENTSERVEXAMP_O) $(EVENTSERVEXAMP_DO)
	@$(MakeLib) $(EVENTSERVEXAMP_LIBNAME) "$(EVENTSERVEXAMP_O) $(EVENTSERVEXAMP_DO)" $(EVENTSERVEXAMP_DIR)

$(EVENTSERVEXAMP_DS): $(EVENTSERVEXAMP_H)  $(EVENTSERVEXAMP_LINKDEF)
	@$(ROOTCINTGO4) $(EVENTSERVEXAMP_H) $(EVENTSERVEXAMP_LINKDEF)

$(EVENTSERVEXAMP_ONLYMAP): $(EVENTSERVEXAMP_LINKDEF) $(EVENTSERVEXAMP_LIB)
	@rm -f $(EVENTSERVEXAMP_ONLYMAP)
	@$(MakeMap) $(EVENTSERVEXAMP_ONLYMAP) $(EVENTSERVEXAMP_SLIB) $(EVENTSERVEXAMP_LINKDEF) "$(ANAL_LIB_DEP)"

all-$(EVENTSERVEXAMP_NAME):     $(EVENTSERVEXAMP_LIB) $(EVENTSERVEXAMP_EXE) map-$(EVENTSERVEXAMP_NAME)

clean-obj-$(EVENTSERVEXAMP_NAME):
	@rm -f $(EVENTSERVEXAMP_O) $(EVENTSERVEXAMP_DO)
	@$(CleanLib) $(EVENTSERVEXAMP_LIBNAME) $(EVENTSERVEXAMP_DIR)
	@rm -f $(EVENTSERVEXAMP_EXEO) $(EVENTSERVEXAMP_EXE)

clean-$(EVENTSERVEXAMP_NAME): clean-obj-$(EVENTSERVEXAMP_NAME)
	@rm -f $(EVENTSERVEXAMP_DEP) $(EVENTSERVEXAMP_DDEP) $(EVENTSERVEXAMP_DS) $(EVENTSERVEXAMP_DH)
	@rm -f $(EVENTSERVEXAMP_EDEP)
	@rm -f $(EVENTSERVEXAMP_ONLYMAP) $(EVENTSERVEXAMP_MAP)

ifdef DOMAP
map-$(EVENTSERVEXAMP_NAME): $(GO4MAP) $(EVENTSERVEXAMP_ONLYMAP)
	@rm -f $(EVENTSERVEXAMP_MAP)
	@cat $(GO4MAP) $(EVENTSERVEXAMP_ONLYMAP) > $(EVENTSERVEXAMP_MAP)
else
map-$(EVENTSERVEXAMP_NAME):

endif
