EXAMP1STEP_NAME        = Go4Example1Step
MODULE_NAME            = $(EXAMP1STEP_NAME)

## normally should be like this for every module, but can be specific

ifdef GO4PACKAGE
EXAMP1STEP_DIR         = $(GO4SYS)/$(EXAMP1STEP_NAME)
else
EXAMP1STEP_DIR         = .
endif

EXAMP1STEP_LINKDEF     = $(EXAMP1STEP_DIR)/Go4UserAnalysisLinkDef.$(HedSuf)
EXAMP1STEP_LIBNAME     = libGo4UserAnalysis
EXAMP1STEP_EXENAME     = MainUserAnalysis
EXAMP1STEP_ONLYMAP     = $(EXAMP1STEP_DIR)/.localmap
EXAMP1STEP_MAP         = $(EXAMP1STEP_DIR)/$(ROOTMAPNAME)

EXAMP1STEP_NOTLIBF     = 

## must be similar for every module

EXAMP1STEP_EXEO        = $(EXAMP1STEP_DIR)/$(EXAMP1STEP_EXENAME).$(ObjSuf)
#EXAMP1STEP_EXEH        = $(EXAMP1STEP_DIR)/$(EXAMP1STEP_EXENAME).$(HedSuf)
EXAMP1STEP_EXES        = $(EXAMP1STEP_DIR)/$(EXAMP1STEP_EXENAME).$(SrcSuf)
EXAMP1STEP_EXE         = $(EXAMP1STEP_DIR)/$(EXAMP1STEP_EXENAME)$(ExeSuf)   

EXAMP1STEP_DICT        = $(EXAMP1STEP_DIR)/$(DICT_PREFIX)$(EXAMP1STEP_NAME)
EXAMP1STEP_DH          = $(EXAMP1STEP_DICT).$(HedSuf)
EXAMP1STEP_DS          = $(EXAMP1STEP_DICT).$(SrcSuf)
EXAMP1STEP_DO          = $(EXAMP1STEP_DICT).$(ObjSuf)

EXAMP1STEP_H           = $(filter-out $(EXAMP1STEP_EXEH) $(EXAMP1STEP_NOTLIBF) $(EXAMP1STEP_DH) $(EXAMP1STEP_LINKDEF), $(wildcard $(EXAMP1STEP_DIR)/*.$(HedSuf)))
EXAMP1STEP_S           = $(filter-out $(EXAMP1STEP_EXES) $(EXAMP1STEP_NOTLIBF) $(EXAMP1STEP_DS), $(wildcard $(EXAMP1STEP_DIR)/*.$(SrcSuf)))
EXAMP1STEP_O           = $(EXAMP1STEP_S:.$(SrcSuf)=.$(ObjSuf))

EXAMP1STEP_DEP         =  $(EXAMP1STEP_O:.$(ObjSuf)=.$(DepSuf))
EXAMP1STEP_DDEP        =  $(EXAMP1STEP_DO:.$(ObjSuf)=.$(DepSuf))
EXAMP1STEP_EDEP        =  $(EXAMP1STEP_EXEO:.$(ObjSuf)=.$(DepSuf))

EXAMP1STEP_SLIB        =  $(EXAMP1STEP_DIR)/$(EXAMP1STEP_LIBNAME).$(DllSuf)
EXAMP1STEP_LIB         =  $(EXAMP1STEP_DIR)/$(EXAMP1STEP_LIBNAME).$(DllSuf).$(VERSSUF)

# used in the main Makefile

EXAMPDEPENDENCS    += $(EXAMP1STEP_DEP) $(EXAMP1STEP_DDEP) $(EXAMP1STEP_EDEP)

ifdef DOPACKAGE
DISTRFILES         += $(EXAMP1STEP_S) $(EXAMP1STEP_H) $(EXAMP1STEP_LINKDEF) $(EXAMP1STEP_EXES)
DISTRFILES         += $(EXAMP1STEP_DIR)/Readme.txt
DISTRFILES         += $(EXAMP1STEP_DIR)/AnalysisStart.sh  $(EXAMP1STEP_DIR)/rename.sh
DISTRFILES         += $(wildcard $(EXAMP1STEP_DIR)/*.C)
endif

##### local rules #####

$(EXAMP1STEP_EXE):      $(BUILDGO4LIBS) $(EXAMP1STEP_EXEO) $(EXAMP1STEP_LIB)
	$(LD) $(LDFLAGS) $(EXAMP1STEP_EXEO) $(LIBS_FULLSET) $(EXAMP1STEP_LIB) $(OutPutOpt) $(EXAMP1STEP_EXE)
	@echo "$@  done"

$(EXAMP1STEP_LIB):   $(EXAMP1STEP_O) $(EXAMP1STEP_DO)
	@$(MakeLib) $(EXAMP1STEP_LIBNAME) "$(EXAMP1STEP_O) $(EXAMP1STEP_DO)" $(EXAMP1STEP_DIR)

$(EXAMP1STEP_DS): $(EXAMP1STEP_H)  $(EXAMP1STEP_LINKDEF)
	@$(ROOTCINTGO4) $(EXAMP1STEP_H) $(EXAMP1STEP_LINKDEF)

$(EXAMP1STEP_ONLYMAP): $(EXAMP1STEP_LINKDEF) $(EXAMP1STEP_LIB)
	@rm -f $(EXAMP1STEP_ONLYMAP)
	@$(MakeMap) $(EXAMP1STEP_ONLYMAP) $(EXAMP1STEP_SLIB) $(EXAMP1STEP_LINKDEF) "$(ANAL_LIB_DEP)"

all-$(EXAMP1STEP_NAME):     $(EXAMP1STEP_LIB) $(EXAMP1STEP_EXE) map-$(EXAMP1STEP_NAME)

clean-obj-$(EXAMP1STEP_NAME):
	@rm -f $(EXAMP1STEP_O) $(EXAMP1STEP_DO)
	@$(CleanLib) $(EXAMP1STEP_LIBNAME) $(EXAMP1STEP_DIR)
	@rm -f $(EXAMP1STEP_EXEO) $(EXAMP1STEP_EXE)

clean-$(EXAMP1STEP_NAME): clean-obj-$(EXAMP1STEP_NAME)
	@rm -f $(EXAMP1STEP_DEP) $(EXAMP1STEP_DDEP) $(EXAMP1STEP_DS) $(EXAMP1STEP_DH)
	@rm -f $(EXAMP1STEP_EDEP)
	@rm -f $(EXAMP1STEP_ONLYMAP) $(EXAMP1STEP_MAP)

ifdef DOMAP
map-$(EXAMP1STEP_NAME): $(GO4MAP) $(EXAMP1STEP_ONLYMAP)
	@rm -f $(EXAMP1STEP_MAP)
	@cat $(GO4MAP) $(EXAMP1STEP_ONLYMAP) > $(EXAMP1STEP_MAP)
else
map-$(EXAMP1STEP_NAME):

endif
