EXAMP2STEP_NAME        = Go4Example2Step
MODULE_NAME            = $(EXAMP2STEP_NAME)

## normally should be like this for every module, but can be specific

ifdef GO4PACKAGE
EXAMP2STEP_DIR         = $(GO4SYS)/$(EXAMP2STEP_NAME)
else
EXAMP2STEP_DIR         = .
endif

EXAMP2STEP_LINKDEF     = $(EXAMP2STEP_DIR)/Go4UserAnalysisLinkDef.$(HedSuf)
EXAMP2STEP_LIBNAME     = libGo4UserAnalysis
EXAMP2STEP_EXENAME     = MainUserAnalysis
EXAMP2STEP_ONLYMAP     = $(EXAMP2STEP_DIR)/.localmap
EXAMP2STEP_MAP         = $(EXAMP2STEP_DIR)/$(ROOTMAPNAME)

EXAMP2STEP_NOTLIBF     = 

## must be similar for every module

EXAMP2STEP_EXEO        = $(EXAMP2STEP_DIR)/$(EXAMP2STEP_EXENAME).$(ObjSuf)
#EXAMP2STEP_EXEH        = $(EXAMP2STEP_DIR)/$(EXAMP2STEP_EXENAME).$(HedSuf)
EXAMP2STEP_EXES        = $(EXAMP2STEP_DIR)/$(EXAMP2STEP_EXENAME).$(SrcSuf)
EXAMP2STEP_EXE         = $(EXAMP2STEP_DIR)/$(EXAMP2STEP_EXENAME)$(ExeSuf)   

EXAMP2STEP_DICT        = $(EXAMP2STEP_DIR)/$(DICT_PREFIX)$(EXAMP2STEP_NAME)
EXAMP2STEP_DH          = $(EXAMP2STEP_DICT).$(HedSuf)
EXAMP2STEP_DS          = $(EXAMP2STEP_DICT).$(SrcSuf)
EXAMP2STEP_DO          = $(EXAMP2STEP_DICT).$(ObjSuf)

EXAMP2STEP_H           = $(filter-out $(EXAMP2STEP_EXEH) $(EXAMP2STEP_NOTLIBF) $(EXAMP2STEP_DH) $(EXAMP2STEP_LINKDEF), $(wildcard $(EXAMP2STEP_DIR)/*.$(HedSuf)))
EXAMP2STEP_S           = $(filter-out $(EXAMP2STEP_EXES) $(EXAMP2STEP_NOTLIBF) $(EXAMP2STEP_DS), $(wildcard $(EXAMP2STEP_DIR)/*.$(SrcSuf)))
EXAMP2STEP_O           = $(EXAMP2STEP_S:.$(SrcSuf)=.$(ObjSuf))

EXAMP2STEP_DEP         =  $(EXAMP2STEP_O:.$(ObjSuf)=.$(DepSuf))
EXAMP2STEP_DDEP        =  $(EXAMP2STEP_DO:.$(ObjSuf)=.$(DepSuf))
EXAMP2STEP_EDEP        =  $(EXAMP2STEP_EXEO:.$(ObjSuf)=.$(DepSuf))

EXAMP2STEP_SLIB        =  $(EXAMP2STEP_DIR)/$(EXAMP2STEP_LIBNAME).$(DllSuf)
EXAMP2STEP_LIB         =  $(EXAMP2STEP_DIR)/$(EXAMP2STEP_LIBNAME).$(DllSuf).$(VERSSUF)

# used in the main Makefile

EXAMPDEPENDENCS    += $(EXAMP2STEP_DEP) $(EXAMP2STEP_DDEP) $(EXAMP2STEP_EDEP)

ifdef DOPACKAGE
DISTRFILES         += $(EXAMP2STEP_S) $(EXAMP2STEP_H) $(EXAMP2STEP_LINKDEF) $(EXAMP2STEP_EXEH) $(EXAMP2STEP_EXES)
DISTRFILES         += $(EXAMP2STEP_DIR)/Readme.txt $(EXAMP2STEP_DIR)/Makefile.win
DISTRFILES         += $(EXAMP2STEP_DIR)/AnalysisStart.sh  $(EXAMP2STEP_DIR)/rename.sh 
DISTRFILES         += $(EXAMP2STEP_DIR)/calilines.txt
DISTRFILES         += $(EXAMP2STEP_DIR)/gaussfiles.lml
DISTRFILES         += $(EXAMP2STEP_DIR)/convertfile.C
DISTRFILES         += $(EXAMP2STEP_DIR)/findobjects.C
DISTRFILES         += $(EXAMP2STEP_DIR)/browse.C
DISTRFILES         += $(EXAMP2STEP_DIR)/plothistos.C
#DISTRFILES         += $(wildcard $(EXAMP2STEP_DIR)/*.C)
endif

##### local rules #####

$(EXAMP2STEP_EXE):      $(BUILDGO4LIBS) $(EXAMP2STEP_EXEO) $(EXAMP2STEP_LIB)
	$(LD) $(LDFLAGS) $(EXAMP2STEP_EXEO) $(LIBS_FULLSET) $(EXAMP2STEP_LIB) $(OutPutOpt) $(EXAMP2STEP_EXE)
	@echo "$@  done"

$(EXAMP2STEP_LIB):   $(EXAMP2STEP_O) $(EXAMP2STEP_DO)
	$(MakeLib) $(EXAMP2STEP_LIBNAME) "$(EXAMP2STEP_O) $(EXAMP2STEP_DO)" $(EXAMP2STEP_DIR)

$(EXAMP2STEP_DS): $(EXAMP2STEP_H)  $(EXAMP2STEP_LINKDEF)
		@$(ROOTCINTGO4) $(EXAMP2STEP_H) $(EXAMP2STEP_LINKDEF)

$(EXAMP2STEP_ONLYMAP): $(EXAMP2STEP_LINKDEF) $(EXAMP2STEP_LIB)
	@rm -f $(EXAMP2STEP_ONLYMAP)
	@$(MakeMap) $(EXAMP2STEP_ONLYMAP) $(EXAMP2STEP_SLIB) $(EXAMP2STEP_LINKDEF) "$(ANAL_LIB_DEP)"

all-$(EXAMP2STEP_NAME):     $(EXAMP2STEP_LIB) $(EXAMP2STEP_EXE) map-$(EXAMP2STEP_NAME)

clean-obj-$(EXAMP2STEP_NAME):
	@rm -f $(EXAMP2STEP_O) $(EXAMP2STEP_DO)
	@$(CleanLib) $(EXAMP2STEP_LIBNAME) $(EXAMP2STEP_DIR)
	@rm -f $(EXAMP2STEP_EXEO) $(EXAMP2STEP_EXE)

clean-$(EXAMP2STEP_NAME): clean-obj-$(EXAMP2STEP_NAME)
	@rm -f $(EXAMP2STEP_DEP) $(EXAMP2STEP_DDEP) $(EXAMP2STEP_DS) $(EXAMP2STEP_DH)
	@rm -f $(EXAMP2STEP_EDEP)
	@rm -f $(EXAMP2STEP_ONLYMAP) $(EXAMP2STEP_MAP)

ifdef DOMAP
map-$(EXAMP2STEP_NAME): $(GO4MAP) $(EXAMP2STEP_ONLYMAP)
	@rm -f $(EXAMP2STEP_MAP)
	@cat $(GO4MAP) $(EXAMP2STEP_ONLYMAP) > $(EXAMP2STEP_MAP)
else
map-$(EXAMP2STEP_NAME):

endif
