EXAMPMESH_NAME        = Go4ExampleMesh
MODULE_NAME            = $(EXAMPMESH_NAME)

## normally should be like this for every module, but can be specific

ifdef GO4PACKAGE
EXAMPMESH_DIR         = $(GO4SYS)/$(EXAMPMESH_NAME)
else
EXAMPMESH_DIR         = .
endif

EXAMPMESH_LINKDEF     = $(EXAMPMESH_DIR)/Go4UserAnalysisLinkDef.$(HedSuf)
EXAMPMESH_LIBNAME     = libGo4UserAnalysis
EXAMPMESH_EXENAME     = MainUserAnalysis
EXAMPMESH_ONLYMAP     = $(EXAMPMESH_DIR)/.localmap
EXAMPMESH_MAP         = $(EXAMPMESH_DIR)/$(ROOTMAPNAME)

EXAMPMESH_NOTLIBF     =

## must be similar for every module

EXAMPMESH_EXEO        = $(EXAMPMESH_DIR)/$(EXAMPMESH_EXENAME).$(ObjSuf)
#EXAMPMESH_EXEH        = $(EXAMPMESH_DIR)/$(EXAMPMESH_EXENAME).$(HedSuf)
EXAMPMESH_EXES        = $(EXAMPMESH_DIR)/$(EXAMPMESH_EXENAME).$(SrcSuf)
EXAMPMESH_EXE         = $(EXAMPMESH_DIR)/$(EXAMPMESH_EXENAME)$(ExeSuf)

EXAMPMESH_DICT        = $(EXAMPMESH_DIR)/$(DICT_PREFIX)$(EXAMPMESH_NAME)
EXAMPMESH_DH          = $(EXAMPMESH_DICT).$(HedSuf)
EXAMPMESH_DS          = $(EXAMPMESH_DICT).$(SrcSuf)
EXAMPMESH_DO          = $(EXAMPMESH_DICT).$(ObjSuf)

EXAMPMESH_H           = $(filter-out $(EXAMPMESH_EXEH) $(EXAMPMESH_NOTLIBF) $(EXAMPMESH_DH) $(EXAMPMESH_LINKDEF), $(wildcard $(EXAMPMESH_DIR)/*.$(HedSuf)))
EXAMPMESH_S           = $(filter-out $(EXAMPMESH_EXES) $(EXAMPMESH_NOTLIBF) $(EXAMPMESH_DS), $(wildcard $(EXAMPMESH_DIR)/*.$(SrcSuf)))
EXAMPMESH_O           = $(EXAMPMESH_S:.$(SrcSuf)=.$(ObjSuf))

EXAMPMESH_DEP         =  $(EXAMPMESH_O:.$(ObjSuf)=.$(DepSuf))
EXAMPMESH_DDEP        =  $(EXAMPMESH_DO:.$(ObjSuf)=.$(DepSuf))
EXAMPMESH_EDEP        =  $(EXAMPMESH_EXEO:.$(ObjSuf)=.$(DepSuf))

EXAMPMESH_SLIB        =  $(EXAMPMESH_DIR)/$(EXAMPMESH_LIBNAME).$(DllSuf)
EXAMPMESH_LIB         =  $(EXAMPMESH_DIR)/$(EXAMPMESH_LIBNAME).$(DllSuf).$(VERSSUF)

# used in the main Makefile

EXAMPDEPENDENCS    += $(EXAMPMESH_DEP) $(EXAMPMESH_DDEP) $(EXAMPMESH_EDEP)

ifdef DOPACKAGE
DISTRFILES         += $(EXAMPMESH_S) $(EXAMPMESH_H) $(EXAMPMESH_LINKDEF) $(EXAMPMESH_EXEH) $(EXAMPMESH_EXES)
DISTRFILES         += $(EXAMPMESH_DIR)/AnalysisStart.sh  $(EXAMPMESH_DIR)/rename.sh
endif

##### local rules #####

$(EXAMPMESH_EXE):      $(BUILDGO4LIBS) $(EXAMPMESH_EXEO) $(EXAMPMESH_LIB)
	$(LD) $(LDFLAGS) $(EXAMPMESH_EXEO) $(LIBS_FULLSET) $(EXAMPMESH_LIB) $(OutPutOpt) $(EXAMPMESH_EXE)
	@echo "$@  done"

$(EXAMPMESH_LIB):   $(EXAMPMESH_O) $(EXAMPMESH_DO)
		@$(MakeLib) $(EXAMPMESH_LIBNAME) "$(EXAMPMESH_O) $(EXAMPMESH_DO)" $(EXAMPMESH_DIR)

$(EXAMPMESH_DS): $(EXAMPMESH_H)  $(EXAMPMESH_LINKDEF)
		@$(ROOTCINTGO4) $(EXAMPMESH_H) $(EXAMPMESH_LINKDEF)

$(EXAMPMESH_ONLYMAP): $(EXAMPMESH_LINKDEF) $(EXAMPMESH_LIB)
	@rm -f $(EXAMPMESH_ONLYMAP)
	@$(MakeMap) $(EXAMPMESH_ONLYMAP) $(EXAMPMESH_SLIB) $(EXAMPMESH_LINKDEF) "$(ANAL_LIB_DEP)"

all-$(EXAMPMESH_NAME):     $(EXAMPMESH_LIB) $(EXAMPMESH_EXE) map-$(EXAMPMESH_NAME)

clean-obj-$(EXAMPMESH_NAME):
	@rm -f $(EXAMPMESH_O) $(EXAMPMESH_DO)
	@$(CleanLib) $(EXAMPMESH_LIBNAME) $(EXAMPMESH_DIR)
	@rm -f $(EXAMPMESH_EXEO) $(EXAMPMESH_EXE)

clean-$(EXAMPMESH_NAME): clean-obj-$(EXAMPMESH_NAME)
	@rm -f $(EXAMPMESH_DEP) $(EXAMPMESH_DDEP) $(EXAMPMESH_DS) $(EXAMPMESH_DH)
	@rm -f $(EXAMPMESH_EDEP)
	@rm -f $(EXAMPMESH_ONLYMAP) $(EXAMPMESH_MAP)

ifdef DOMAP
map-$(EXAMPMESH_NAME): $(GO4MAP) $(EXAMPMESH_ONLYMAP)
	@rm -f $(EXAMPMESH_MAP)
	@cat $(GO4MAP) $(EXAMPMESH_ONLYMAP) > $(EXAMPMESH_MAP)
else
map-$(EXAMPMESH_NAME):

endif
