EXAMPSIMP_NAME        = Go4ExampleSimple
MODULE_NAME            = $(EXAMPSIMP_NAME)

## normally should be like this for every module, but can be specific

ifdef GO4PACKAGE
EXAMPSIMP_DIR         = $(GO4SYS)/$(EXAMPSIMP_NAME)
else
EXAMPSIMP_DIR         = .
endif

EXAMPSIMP_LINKDEF     = $(EXAMPSIMP_DIR)/Go4UserAnalysisLinkDef.$(HedSuf)
EXAMPSIMP_LIBNAME     = libGo4UserAnalysis
EXAMPSIMP_EXENAME     = MainUserAnalysis
EXAMPSIMP_ONLYMAP     = $(EXAMPSIMP_DIR)/.localmap
EXAMPSIMP_MAP         = $(EXAMPSIMP_DIR)/$(ROOTMAPNAME)

EXAMPSIMP_NOTLIBF     = 

## must be similar for every module

EXAMPSIMP_EXEO        = $(EXAMPSIMP_DIR)/$(EXAMPSIMP_EXENAME).$(ObjSuf)
#EXAMPSIMP_EXEH        = $(EXAMPSIMP_DIR)/$(EXAMPSIMP_EXENAME).$(HedSuf)
EXAMPSIMP_EXES        = $(EXAMPSIMP_DIR)/$(EXAMPSIMP_EXENAME).$(SrcSuf)
EXAMPSIMP_EXE         = $(EXAMPSIMP_DIR)/$(EXAMPSIMP_EXENAME)$(ExeSuf)

EXAMPSIMP_DICT        = $(EXAMPSIMP_DIR)/$(DICT_PREFIX)$(EXAMPSIMP_NAME)
EXAMPSIMP_DH          = $(EXAMPSIMP_DICT).$(HedSuf)
EXAMPSIMP_DS          = $(EXAMPSIMP_DICT).$(SrcSuf)
EXAMPSIMP_DO          = $(EXAMPSIMP_DICT).$(ObjSuf)

EXAMPSIMP_H           = $(filter-out $(EXAMPSIMP_EXEH) $(EXAMPSIMP_NOTLIBF) $(EXAMPSIMP_DH) $(EXAMPSIMP_LINKDEF), $(wildcard $(EXAMPSIMP_DIR)/*.$(HedSuf)))
EXAMPSIMP_S           = $(filter-out $(EXAMPSIMP_EXES) $(EXAMPSIMP_NOTLIBF) $(EXAMPSIMP_DS), $(wildcard $(EXAMPSIMP_DIR)/*.$(SrcSuf)))
EXAMPSIMP_O           = $(EXAMPSIMP_S:.$(SrcSuf)=.$(ObjSuf))

EXAMPSIMP_DEP         =  $(EXAMPSIMP_O:.$(ObjSuf)=.$(DepSuf))
EXAMPSIMP_DDEP        =  $(EXAMPSIMP_DO:.$(ObjSuf)=.$(DepSuf))
EXAMPSIMP_EDEP        =  $(EXAMPSIMP_EXEO:.$(ObjSuf)=.$(DepSuf))

EXAMPSIMP_SLIB        =  $(EXAMPSIMP_DIR)/$(EXAMPSIMP_LIBNAME).$(DllSuf)
EXAMPSIMP_LIB         =  $(EXAMPSIMP_DIR)/$(EXAMPSIMP_LIBNAME).$(DllSuf).$(VERSSUF)

# used in the main Makefile

EXAMPDEPENDENCS    += $(EXAMPSIMP_DEP) $(EXAMPSIMP_DDEP) $(EXAMPSIMP_EDEP)

ifdef DOPACKAGE
DISTRFILES         += $(EXAMPSIMP_S) $(EXAMPSIMP_H) $(EXAMPSIMP_LINKDEF) $(EXAMPSIMP_EXEH) $(EXAMPSIMP_EXES)
DISTRFILES         += $(EXAMPSIMP_DIR)/Readme.txt
DISTRFILES         += $(EXAMPSIMP_DIR)/AnalysisStart.sh $(EXAMPSIMP_DIR)/rename.sh 
DISTRFILES         += $(EXAMPSIMP_DIR)/*.C 
endif

##### local rules #####

$(EXAMPSIMP_EXE):      $(BUILDGO4LIBS) $(EXAMPSIMP_EXEO) $(EXAMPSIMP_LIB)
	$(LD) $(LDFLAGS) $(EXAMPSIMP_EXEO) $(LIBS_FULLSET) $(EXAMPSIMP_LIB) $(OutPutOpt) $(EXAMPSIMP_EXE)
	@echo "$@  done"

$(EXAMPSIMP_LIB):   $(EXAMPSIMP_O) $(EXAMPSIMP_DO)
	@$(MakeLib) $(EXAMPSIMP_LIBNAME) "$(EXAMPSIMP_O) $(EXAMPSIMP_DO)" $(EXAMPSIMP_DIR)

$(EXAMPSIMP_DS): $(EXAMPSIMP_H)  $(EXAMPSIMP_LINKDEF)
	@$(ROOTCINTGO4) $(EXAMPSIMP_H) $(EXAMPSIMP_LINKDEF)

$(EXAMPSIMP_ONLYMAP): $(EXAMPSIMP_LINKDEF) $(EXAMPSIMP_LIB)
	@rm -f $(EXAMPSIMP_ONLYMAP)
	@$(MakeMap) $(EXAMPSIMP_ONLYMAP) $(EXAMPSIMP_SLIB) $(EXAMPSIMP_LINKDEF) "$(ANAL_LIB_DEP)"

all-$(EXAMPSIMP_NAME):     $(EXAMPSIMP_LIB) $(EXAMPSIMP_EXE) map-$(EXAMPSIMP_NAME)

clean-obj-$(EXAMPSIMP_NAME):
	@rm -f $(EXAMPSIMP_O) $(EXAMPSIMP_DO)
	@$(CleanLib) $(EXAMPSIMP_LIBNAME) $(EXAMPSIMP_DIR)
	@rm -f $(EXAMPSIMP_EXEO) $(EXAMPSIMP_EXE)

clean-$(EXAMPSIMP_NAME): clean-obj-$(EXAMPSIMP_NAME)
	@rm -f $(EXAMPSIMP_DEP) $(EXAMPSIMP_DDEP) $(EXAMPSIMP_DS) $(EXAMPSIMP_DH)
	@rm -f $(EXAMPSIMP_EDEP)
	@rm -f $(EXAMPSIMP_ONLYMAP) $(EXAMPSIMP_MAP)

ifdef DOMAP
map-$(EXAMPSIMP_NAME): $(GO4MAP) $(EXAMPSIMP_ONLYMAP)
	@rm -f $(EXAMPSIMP_MAP)
	@cat $(GO4MAP) $(EXAMPSIMP_ONLYMAP) > $(EXAMPSIMP_MAP)
else
map-$(EXAMPSIMP_NAME):

endif
