//---------------------------------------------------------------
//        Go4 Release Package v3.03-01a (build 30301a)
//                      10-July-2007
//---------------------------------------------------------------
//   The GSI Online Offline Object Oriented (Go4) Project
//   Experiment Data Processing at EE department, GSI
//---------------------------------------------------------------
//
//Copyright (C) 2000- Gesellschaft f. Schwerionenforschung, GSI
//                    Planckstr. 1, 64291 Darmstadt, Germany
//Contact:            http://go4.gsi.de
//----------------------------------------------------------------
//This software can be used under the license agreements as stated
//in Go4License.txt file which is part of the distribution.
//----------------------------------------------------------------
#include "TYYYUnpackEvent.h"

#include "Riostream.h"

#include "TYYYUnpackProc.h"
#include "TGo4FileSource.h"

//***********************************************************
TYYYUnpackEvent::TYYYUnpackEvent()
  :TGo4EventElement("YYYUnpackEvent"),fxYYYEP(0),fxYYYFS(0)
{
}
//***********************************************************
TYYYUnpackEvent::TYYYUnpackEvent(const char* name)
  :TGo4EventElement(name),fxYYYEP(0),fxYYYFS(0)
{
}
//***********************************************************
TYYYUnpackEvent::~TYYYUnpackEvent()
{
}
//***********************************************************

//-----------------------------------------------------------
Int_t TYYYUnpackEvent::Init()
{
  Int_t rev=0;
  //cout << "+++ Init event" << endl;
  Clear();
  // is it used by Unpack step as output?
  if(CheckEventSource("TYYYUnpackProc")){
    fxYYYEP = (TYYYUnpackProc*)GetEventSource();
    cout << "**** YYYUnpackEvent init for Unpack step"<< endl;
  }
  // or is it used from Analysis step as input
  else if(CheckEventSource("TGo4FileSource")){
    fxYYYFS = (TGo4FileSource*)GetEventSource();
    cout << "**** YYYUnpackEvent init for Analysis step"<< endl;
  }
  else          rev=1;
  return rev;
}
//-----------------------------------------------------------
Int_t TYYYUnpackEvent::Fill()
{
   Int_t rev=0;
   Clear();
   if(fxYYYEP)fxYYYEP->YYYUnpack(this);  // user event processing method
   if(fxYYYFS)fxYYYFS->BuildEvent(this); // method from framework to restore event from file
   return rev;
}

//-----------------------------------------------------------
void  TYYYUnpackEvent::Clear(Option_t *t)
{
void* destfield;
   //cout << "+++ event clear" << endl;
   destfield = (void*) &fdR[0];
   memset(destfield,0, sizeof(fdR));
   destfield = (void*) &fdV[0];
   memset(destfield,0, sizeof(fdV));
   destfield = (void*) &fdGam[0];
   memset(destfield,0, sizeof(fdGam));
   fiNumScatt=0;
   fdEmittX=0;
   fdEmittY=0;
   fdEmitt4d=0;

   //cout << "+++ event clear" << endl;
}

//----------------------------END OF GO4 SOURCE FILE ---------------------
