//---------------------------------------------------------------
//        Go4 Release Package v3.03-01a (build 30301a)
//                      10-July-2007
//---------------------------------------------------------------
//   The GSI Online Offline Object Oriented (Go4) Project
//   Experiment Data Processing at EE department, GSI
//---------------------------------------------------------------
//
//Copyright (C) 2000- Gesellschaft f. Schwerionenforschung, GSI
//                    Planckstr. 1, 64291 Darmstadt, Germany
//Contact:            http://go4.gsi.de
//----------------------------------------------------------------
//This software can be used under the license agreements as stated
//in Go4License.txt file which is part of the distribution.
//----------------------------------------------------------------
#ifndef TYYYUNPACKPROCESSOR_H
#define TYYYUNPACKPROCESSOR_H

#include "TGo4EventProcessor.h"

class TYYYUnpackEvent;
class TYYYRawEvent;
class TYYYParameter;

class TYYYUnpackProc : public TGo4EventProcessor {
   public:
      TYYYUnpackProc() ;
      TYYYUnpackProc(const char* name);
      void YYYUnpack(TYYYUnpackEvent* target);
      virtual ~TYYYUnpackProc() ;
   private:
      TH1D          *fX;
      TH1D          *fY;
      TH1D          *fZ;
      TH1D          *fVX;
      TH1D          *fVY;
      TH1D          *fVZ;
      TH1D          *fNumScatt;
      TH2D          *fXY;
      TH2D          *fVXVY;
      TH2D          *fXYCond;
      TH2D          *fVXVYCond;
      TH2D          *fEmitX;
      TH2D          *fEmitY;
      TH1D         *fEmitDist;
      TGo4WinCond   *fWinConR;
      TGo4WinCond   *fWinConV;
      TGo4PolyCond  *fPolyConEmit;
      TYYYRawEvent  *fInput;
      TYYYParameter *fParam1;
      TYYYParameter *fParam2;

   ClassDef(TYYYUnpackProc,1)
};

#endif //TYYYUNPACKPROCESSOR_H

//----------------------------END OF GO4 SOURCE FILE ---------------------
