THRDMNGREXAMP_NAME        = Go4ThreadManagerExample
MODULE_NAME         = $(THRDMNGREXAMP_NAME)

## normally should be like this for every module, but can be specific

ifdef GO4PACKAGE
THRDMNGREXAMP_DIR         = $(GO4SYS)/$(THRDMNGREXAMP_NAME)
else
THRDMNGREXAMP_DIR         = .
endif

THRDMNGREXAMP_LINKDEF     = $(THRDMNGREXAMP_DIR)/$(THRDMNGREXAMP_NAME)LinkDef.$(HedSuf)
THRDMNGREXAMP_LIBNAME     = $(LIB_PREFIX)$(THRDMNGREXAMP_NAME)
THRDMNGREXAMP_EXENAME     = Main$(THRDMNGREXAMP_NAME)
THRDMNGREXAMP_ONLYMAP     = $(THRDMNGREXAMP_DIR)/.localmap
THRDMNGREXAMP_MAP         = $(THRDMNGREXAMP_DIR)/$(ROOTMAPNAME)

THRDMNGREXAMP_NOTLIBF     = 

## must be similar for every module

THRDMNGREXAMP_EXEO        = $(THRDMNGREXAMP_DIR)/$(THRDMNGREXAMP_EXENAME).$(ObjSuf)
THRDMNGREXAMP_EXES        = $(THRDMNGREXAMP_DIR)/$(THRDMNGREXAMP_EXENAME).$(SrcSuf)
THRDMNGREXAMP_EXE         = $(THRDMNGREXAMP_DIR)/$(THRDMNGREXAMP_EXENAME)$(ExeSuf)   

THRDMNGREXAMP_DICT        = $(THRDMNGREXAMP_DIR)/$(DICT_PREFIX)$(THRDMNGREXAMP_NAME)
THRDMNGREXAMP_DH          = $(THRDMNGREXAMP_DICT).$(HedSuf)
THRDMNGREXAMP_DS          = $(THRDMNGREXAMP_DICT).$(SrcSuf)
THRDMNGREXAMP_DO          = $(THRDMNGREXAMP_DICT).$(ObjSuf)

THRDMNGREXAMP_H           = $(filter-out $(THRDMNGREXAMP_NOTLIBF) $(THRDMNGREXAMP_DH) $(THRDMNGREXAMP_LINKDEF), $(wildcard $(THRDMNGREXAMP_DIR)/*.$(HedSuf)))
THRDMNGREXAMP_S           = $(filter-out $(THRDMNGREXAMP_EXES) $(THRDMNGREXAMP_NOTLIBF) $(THRDMNGREXAMP_DS), $(wildcard $(THRDMNGREXAMP_DIR)/*.$(SrcSuf)))
THRDMNGREXAMP_O           = $(THRDMNGREXAMP_S:.$(SrcSuf)=.$(ObjSuf))

THRDMNGREXAMP_DEP         =  $(THRDMNGREXAMP_O:.$(ObjSuf)=.$(DepSuf))
THRDMNGREXAMP_DDEP        =  $(THRDMNGREXAMP_DO:.$(ObjSuf)=.$(DepSuf))
THRDMNGREXAMP_EDEP        =  $(THRDMNGREXAMP_EXEO:.$(ObjSuf)=.$(DepSuf))

THRDMNGREXAMP_SLIB        =  $(THRDMNGREXAMP_DIR)/$(THRDMNGREXAMP_LIBNAME).$(DllSuf)
THRDMNGREXAMP_LIB         =  $(THRDMNGREXAMP_DIR)/$(THRDMNGREXAMP_LIBNAME).$(DllSuf).$(VERSSUF)

# used in the main Makefile

EXAMPDEPENDENCS    += $(THRDMNGREXAMP_DEP) $(THRDMNGREXAMP_DDEP) $(THRDMNGREXAMP_EDEP)

ifdef DOPACKAGE
THRDMNGREXAMP_DISTRFILES = $(THRDMNGREXAMP_S) $(THRDMNGREXAMP_H) $(THRDMNGREXAMP_LINKDEF) $(THRDMNGREXAMP_EXES)
DISTRFILES         += $(THRDMNGREXAMP_DISTRFILES)
endif

##### local rules #####

$(THRDMNGREXAMP_EXE):     $(THRDMNGREXAMP_EXEO) $(THRDMNGREXAMP_LIB) 
	$(LD) $(LDFLAGS) $(THRDMNGREXAMP_EXEO) $(LIBS_THRDMANSET) $(THRDMNGREXAMP_LIB) $(OutPutOpt) $(THRDMNGREXAMP_EXE)
	@echo "$@  done"      

$(THRDMNGREXAMP_LIB):   $(THRDMNGREXAMP_O) $(THRDMNGREXAMP_DO)
		@$(MakeLib) $(THRDMNGREXAMP_LIBNAME) "$(THRDMNGREXAMP_O) $(THRDMNGREXAMP_DO)" $(THRDMNGREXAMP_DIR)

$(THRDMNGREXAMP_DS): $(THRDMNGREXAMP_H)  $(THRDMNGREXAMP_LINKDEF)
		@$(ROOTCINTGO4) $(THRDMNGREXAMP_H) $(THRDMNGREXAMP_LINKDEF)

$(THRDMNGREXAMP_ONLYMAP): $(THRDMNGREXAMP_LINKDEF) $(THRDMNGREXAMP_LIB)
	@rm -f $(THRDMNGREXAMP_ONLYMAP)
	@$(MakeMap) $(THRDMNGREXAMP_ONLYMAP) $(THRDMNGREXAMP_SLIB) $(THRDMNGREXAMP_LINKDEF) "$(THRDMNGR_SLIB) $(GO4BASE_SLIB) $(ROOTSYS)/lib/libThread.so"

all-$(THRDMNGREXAMP_NAME):     $(THRDMNGREXAMP_LIB) $(THRDMNGREXAMP_EXE) map-$(THRDMNGREXAMP_NAME)

clean-obj-$(THRDMNGREXAMP_NAME):
		@rm -f $(THRDMNGREXAMP_O) $(THRDMNGREXAMP_DO)
		@$(CleanLib) $(THRDMNGREXAMP_LIBNAME) $(THRDMNGREXAMP_DIR)
		@rm -f $(THRDMNGREXAMP_EXEO) $(THRDMNGREXAMP_EXE)

clean-$(THRDMNGREXAMP_NAME): clean-obj-$(THRDMNGREXAMP_NAME)
		@rm -f $(THRDMNGREXAMP_DEP) $(THRDMNGREXAMP_DDEP) $(THRDMNGREXAMP_DS) $(THRDMNGREXAMP_DH)
		@rm -f $(THRDMNGREXAMP_EDEP)
		@rm -f $(THRDMNGREXAMP_ONLYMAP) $(THRDMNGREXAMP_MAP)

ifdef DOMAP
map-$(THRDMNGREXAMP_NAME): $(GO4MAP) $(THRDMNGREXAMP_ONLYMAP)
	@rm -f $(THRDMNGREXAMP_MAP)
	@cat $(GO4MAP) $(THRDMNGREXAMP_ONLYMAP) > $(THRDMNGREXAMP_MAP)
else
map-$(THRDMNGREXAMP_NAME):

endif
